//
// OpenCV program to find contours in a series of images and output mel script
//

#include "cv.h"  // include core library interface
#include "highgui.h" // include GUI library interface
#include <stdio.h>
#include <math.h>
#include <string.h>

CvMemStorage* storage = 0; //setup some OpenCv storage stuff we need
CvSeq* contours = 0; //contours will go in here
CvPoint pt[500]; //our list of points
FILE *Fp; //file pointer to write the mel script
int points;
int totalPoints = 0;


IplImage* edgeDetect( IplImage* img0){ // edgedetect function, takes in image



	int i=0;
	int k;
	int contourCounter = 0;
	//int count=100;
	CvSeqReader reader;


	CvMemStorage* storage;


	CvSeq* result;
	CvSize sz = cvSize( img0->width, img0->height); //get size of image we just brought in

	IplImage* contourImage = 0;

	IplImage* gray1 = cvCreateImage( sz, IPL_DEPTH_8U, 1 ); // //create blank 8bit image the same size
	IplImage* red = cvCreateImage( sz, 8, 1 ); // create more images for each plane.
	IplImage* blue = cvCreateImage( sz, 8, 1 );
	IplImage* green = cvCreateImage( sz, 8, 1 );
	IplImage* alpha = 0;


	storage = cvCreateMemStorage(0);



	cvCvtPixToPlane( img0, red, blue, green, alpha); //split our image into it's channels so we can get a grayscale image.

	cvCanny( green, gray1, 0.1, 20, 5); //canny edgedetect it
	cvvShowImage( "image", gray1 ); //show it to the screen
	cvDilate( gray1, gray1, 0, 2 ); //dialate a bit to help contour reader



	//contour stuff


	//find me some contours
	contourCounter = cvFindContours( gray1, storage, &contours, sizeof(CvContour), CV_RETR_EXTERNAL, CV_CHAIN_APPROX_TC89_L1 );


	}






	//reader stuff
	//lets get at what the contour reader found

	cvStartReadSeq( contours, &reader, 1 ); // open the contour list
	points = cvGetSeqReaderPos( &reader );//get how many points it found ->where we are at the moment
	totalPoints = totalPoints + points;

	//for all the points, reading from the end

	for (k=0;k<=points;k++){

		int pos;
		pos = cvGetSeqReaderPos( &reader ); //find out where we are
		//printf("position equals... %d \n", pos);


		if(pos>=0){ //while were not at the start


			CV_REV_READ_SEQ_ELEM( pt[k], reader ); //read off some points


						}

	}
	//weve reached the start
	//reread a couple of points to maintain continuity

	CV_REV_READ_SEQ_ELEM( pt[points+1], reader );
	CV_REV_READ_SEQ_ELEM( pt[points+2], reader );

	cvClearMemStorage( storage );


	return gray1;


}



// mel script printing function
void print(int avgPoints, int currentFrame){


	int a,b,j;


	if ((Fp = fopen("curve.mel", "a")) == NULL) //append to file
           fprintf(stderr, "Cannot open %s\n", "output_file");
	fprintf(Fp, "\n //Starting Frame %d...// \n", currentFrame);

	fprintf(Fp, "curve"); //print the mel curve command, and all the points we need for that frame

	for (j=0;j<points+2;j++){

	a = pt[j].x;
	b = pt[j].y;
	fprintf(Fp, " -p %d 0 %d ", a, b);

	}

	printf("printed %d points to file... \n", points+2); //feedback to the screen

	//weve got loads of points, and differnet for every frame. Rebuild to an average so we can blendshape.

	fprintf(Fp, "; \n");
	fprintf(Fp, "select curve%d; \n", currentFrame);
	fprintf(Fp, "rebuildCurve -ch 1 -rpo 0 -rt 0 -end 1 -kr 0 -kcp 0 -kep 1 -kt 0 -s %d -d 3 -tol 0.01; \n", avgPoints);
	fprintf(Fp, "select -r curve%d; \n", currentFrame);
	fprintf(Fp, "HideSelectedObjects; \n");

	fclose(Fp);
}

void postPrint(int totalFrames) //tidiying up in Maya

{

	int counter;


	if ((Fp = fopen("curve.mel", "a")) == NULL)
           fprintf(stderr, "Cannot open %s\n", "output_file");

	fprintf(Fp, "\n //Post Printing// \n");

	//selecting all objects

	fprintf(Fp, "select -r ");

	for(counter=1;counter<=totalFrames;counter++){


		fprintf(Fp, "curve%drebuiltCurve1 ", counter);

	}
	fprintf(Fp, "; \n");

	//deleting History


	fprintf(Fp, "DeleteHistory; \n");
	fprintf(Fp, "select -cl; \n");

	//selecting all original curves

	fprintf(Fp, "select -r ");

	for(counter=1;counter<=totalFrames;counter++){


		fprintf(Fp, "curve%d ", counter);

	}
	fprintf(Fp, "; \n");

	//deleting

	fprintf(Fp, "delete; \n");
	fprintf(Fp, "select -cl; \n");

	//selecting for blendShapes

	fprintf(Fp, "select -r ");

	for(counter=2;counter<=totalFrames;counter++){


		fprintf(Fp, "curve%drebuiltCurve1 ", counter);

	}
	fprintf(Fp, "; \n");

	fprintf(Fp, "select -add curve1rebuiltCurve1; \n") ;

	//blendShape

	fprintf(Fp, "blendShape -ib; \n");

	//hiding blendShape targets


	fprintf(Fp, "select -r ");

	for(counter=2;counter<=totalFrames;counter++){


		fprintf(Fp, "curve%drebuiltCurve1 ", counter);

	}
	fprintf(Fp, "; \n");

	fprintf(Fp, "HideSelectedObjects; \n");

	//keying animation

	fprintf(Fp, "select -r curve1rebuiltCurve1; \n");
	fprintf(Fp, "select -addFirst blendShape1; \n");
	fprintf(Fp, "currentTime 1; \n");
	fprintf(Fp, "setAttr \"blendShape1.curve%drebuiltCurve1\" 0; \n", totalFrames);
	fprintf(Fp, "setKeyframe \"blendShape1.curve%drebuiltCurve1\"; \n", totalFrames);
	fprintf(Fp, "currentTime %d; \n", totalFrames);
	fprintf(Fp, "setAttr \"blendShape1.curve%drebuiltCurve1\" 1; \n", totalFrames);
	fprintf(Fp, "setKeyframe \"blendShape1.curve%drebuiltCurve1\"; \n", totalFrames);

	//rebuilding animated curve

	fprintf(Fp, "select -r curve1rebuiltCurve1 ; \n");
	fprintf(Fp, "rebuildCurve -ch 1 -rpo 0 -rt 0 -end 1 -kr 0 -kcp 0 -kep 1 -kt 0 -s 12 -d 3 -tol 0.01; \n");
	fprintf(Fp, "select -r curve1rebuiltCurve1; \n");
	fprintf(Fp, "HideSelectedObjects; \n");

	fprintf(Fp, "\n \n // done postPrinting // \n \n");

	fclose(Fp);



}

void destroy(){ //little tidying function

	CvSeq* contours = 0;
	points = 0;



}

void setupFile(){ //setup our mel script file. We'll append to this later

if ((Fp = fopen("curve.mel", "w")) == NULL)
           fprintf(stderr, "Cannot open %s\n", "output_file");
fprintf(Fp, "// start of curve file // \n");
fclose(Fp);

}

void finishFile(){//finished our script, just printing to make sure we got here.

	if ((Fp = fopen("curve.mel", "a")) == NULL)
           fprintf(stderr, "Cannot open %s\n", "output_file");
	fprintf(Fp, "\n \n \n // end of curve file // \n");
	fclose(Fp);

}





int main(int argc, char *argv[3]) //main func, takes in filename, start frame and end frame
{
		int end, current;
		int avgPoints =0;

		char *name;
		IplImage* img0 = 0; //create some OpenCv images
		IplImage* img1 = 0;

		name = argv[1];


		current = atoi(argv[2]);
		end = atoi(argv[3]);

	printf("Starting Curver.... \n"); //print to the screen
	printf("Opening Window.... \n");


    cvvNamedWindow( "image", 1 ); // create HighGUI window with name "image"
	setupFile();

	printf("Starting average point assessment... \n");

	for(current;current<=end;current++){
		char *paddedName[300];
		sprintf( paddedName, "%s.%.4d.bmp", name, current );
		//printf("filename equals..... %s \n", paddedName);
		img0 = cvvLoadImage( paddedName );

		//cvvShowImage( "image", img0 );

		edgeDetect (img0); //call the edge and contour, to find the average number of points were gonna get


										}

		avgPoints = totalPoints/end;

		destroy(); //cleanup
		current = atoi(argv[2]);

		printf("Average points will be %d per frame.... \n", avgPoints);

		printf("Starting Proper Stuff.... \n");

	for(current;current<=end;current++){

		char *paddedName[300];
		sprintf( paddedName, "%s.%.4d.bmp", name, current );
		//printf("filename equals..... %s \n", paddedName);
		img0 = cvvLoadImage( paddedName );
		//cvvShowImage( "image", img0 );

		edgeDetect (img0); //call edge func again

		print(avgPoints, current); //print points to file

		destroy(); //cleanup



	}

		postPrint(end); //finish off Mel script with some tidying


		totalPoints = 0;
		avgPoints =0;
		finishFile(); //finish file properly
		printf("Finished! \n");
		cvvWaitKey(0);
         // wait for key. The function has
                       // an event processing loop inside

        cvReleaseImage( &img0 );



//all done
    return 0;
}
